/* Sorry poor source and English (^^; */
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>

#define DATASIZE 262144	// Size of Save Data
#define SAV	0
#define DUC	500
#define DAT	1024

typedef unsigned int addr;
typedef unsigned char data;

void Error(void);
void ReadSaveData(void);
void WriteSaveData(void);
void ModifyCheckSum(addr, addr);

data *buf, *bp;
int SAVETYPE;	// for Other Save Type
int FILESIZE;	// Size of Save File

void Error(void){
	printf("Input Enter-key to Exit: ");
	getchar();
	free(buf);
	exit(1);
}

void ReadSaveData(void){
	FILE *fp;
	char *fname;
	
	if((fp = fopen("ff3.sav", "rb")) != NULL){
		fname = "ff3.sav";
		SAVETYPE = SAV;
	} else if((fp = fopen("ff3.duc", "rb")) != NULL){
		fname = "ff3.duc";
		SAVETYPE = DUC;
	} else if((fp = fopen("ff3.dat", "rb")) != NULL){
		fname = "ff3.dat";
		SAVETYPE = DAT;
	} else {
		printf("Not Found Save File: ff3.sav / ff3.duc / ff3.dat\n");
		Error();
	}
	
	FILESIZE = DATASIZE + SAVETYPE;
	
	if(filelength(fileno(fp)) != FILESIZE){
		printf("Incorrect File Size: size of %s should be %d byte\n", fname, FILESIZE);
		Error();
	}
	
	buf = (data*)malloc(FILESIZE);
	fread(buf, 1, FILESIZE, fp);
	fclose(fp);
	
	if(SAVETYPE == DUC){
		bp = buf;
		buf += SAVETYPE;
	}
	
	if(strncmp(buf, "cd1000", 6)){
		printf("Incorrect Save Data: not FF3 save data\n");
		Error();
	}
}

void WriteSaveData()
{
	FILE *fp;
	char *fname;
	
	switch(SAVETYPE)
	{
	case SAV:
		fname = "ff3.sav";
		break;
	
	case DUC:
		fname = "ff3.duc";
		break;
	
	case DAT:
		fname = "ff3.dat";
		break;
	
	default:
		printf("Error: cannot write save file\n");
		Error();
		break;
	}
	
	fp = fopen(fname, "wb");
	if(SAVETYPE == DUC){
		buf = bp;
	}
	fwrite(buf, 1, FILESIZE, fp);
	fclose(fp);
}

void ModifyCheckSum(addr begin, addr end){
	double sum = 0;
	unsigned long int sum2;
	addr i;
	for(i=begin+0x10; i <= end; i+=4){
		sum += buf[i] + buf[i+1]*0x100 + buf[i+2]*0x10000 + buf[i+3]*0x1000000;
		if(sum >= 0x100000000) sum -= 0x100000000;
	}
	if(sum < 0x3B10){
		sum += 0x100000000;	
	}
	sum -= 0x3B10;
	sum2 = sum;
	for(i=0xC; i <= 0xF; i++){
		buf[begin+i] = sum2 % 0x100;
		sum2 = (sum2 - buf[begin+i]) / 0x100;
	}
}

main(){
	int i;
	addr head=0x0, begin=0x10, end=0x3B0F;
	
	printf("===== FF3DS Sum Adjuster =====\n");
	
    ReadSaveData();
	for(i=0; i < 3; i++){
		if(strncmp(buf+head, "cd1000", 6) == 0){
			ModifyCheckSum(begin, end);
		}
		head += 0x3B10;
		begin += 0x3B10;
		end += 0x3B10;
	}
	WriteSaveData();
	
	free(buf);
    exit(0);
}
/* End of source */
